
Date.prototype.yyyymmdd = function()
{
	return [this.getFullYear(), this.getMonth() + 1, this.getDate()].join('-');
};

Date.prototype.time24 = function()
{
	var hours = this.getHours();
	if (hours < 10)
		hours = '0'+hours;

	var minutes = this.getMinutes();
	if (minutes < 10)
		minutes = '0'+minutes;

	return [hours, minutes].join(':');
};

Date.prototype.formatCs = function()
{
	return [this.getDate(), this.getMonth() + 1, this.getFullYear()].join('. ');
};

Date.prototype.formatInt = function()
{
	return this.getDate()+' '+dpp.t('month-'+this.getMonth()+'-short')+' '+this.getFullYear();
};

window.dpp = {

	currentPage: null,
	startTime: 0,
	isCordova: false,
	data: null,
	datePickers: null,

	pages: {
		transport: {
			title: 'menu-transport',
			start: function()
			{
				ga('send', 'event', 'General', 'ViewTransport');
			}
		},
		about: {
			title: 'menu-about',
			start: function()
			{
				ga('send', 'event', 'General', 'ViewAbout');
			}
		},
		otherapps: {
			title: 'menu-otherapps',
			start: function()
			{
				ga('send', 'event', 'General', 'ViewOtherApps');
			}
		},
		symbols: {
			title: 'menu-symbols',
			start: function()
			{
				ga('send', 'event', 'General', 'ViewSymbols');
			}
		},
		aboutapp: {
			title: 'menu-aboutapp',
			start: function()
			{
				ga('send', 'event', 'General', 'ViewAboutApp');
			}
		},
	},

	init: function()
	{
		console.log('Initializing...');

		/*if( /(android)/i.test(window.navigator.userAgent) ) { // for android & amazon-fireos
			window.ads = {
				banner: 'ca-app-pub-2753783896820626/7654907792',
				interstitial: 'ca-app-pub-2753783896820626/6778778192',
				rewarded: 'ca-app-pub-2753783896820626/1608374191'
			};
		} else if(/(ipod|iphone|ipad)/i.test(navigator.userAgent)) { // for ios
			window.ads = {
				banner: 'ca-app-pub-xxx/zzz', // or DFP format "/6253334/dfp_example_ad"
				interstitial: 'ca-app-pub-xxx/kkk'
			};
		} else { // for windows phone
		window.ads = {
				banner: 'ca-app-pub-xxx/zzz', // or DFP format "/6253334/dfp_example_ad"
				interstitial: 'ca-app-pub-xxx/kkk'
			};
		}*/

		document.addEventListener('onAdDismiss', function(e)
		{
			$.get('http://res.dppapp.cz/api/?action=logadstat&event=dismiss', function(res)
			{
				dpp.loadCampaign();
			});

		    dpp.alert(dpp.t('ads-alert-title'), "<p>"+dpp.t('ads-alert-text1')+"</p><br><h5>"+dpp.t('ads-alert-heading1')+"</h5><p>"+dpp.t('ads-alert-text2')+"</p>");
		});

		var page = window.location.href.split('#')[1];
		
		if (!dpp.pages[page])
			page = 'search';

		dpp.go2(page);
		dpp.currentPage = page;

		$(window).resize(function()
		{
			if (dpp.pages[dpp.currentPage].adjustUi)
				dpp.pages[dpp.currentPage].adjustUi();
		});

		dpp.switchLang(dpp.getLang());

		dpp.pages.savedconnections.registerNotificationCallback();

		$('a:not(.no-forward)').click(dpp.forward);
		dpp.addAutocomplete();

		switch (dpp.getStoredValue('settings-timepicker', 'round'))
		{
			case 'scrolling15':
				$('#search-time').pickatime({
					closeOnSelect: true,
					closeOnClear: false,
					interval: 15,
					format: 'HH:i',
					clear: ''
				});
			break;

			case 'typing':
				$('#search-time').prop('readonly', false);
			break;
			
			case 'scrolling30':
				$('#search-time').pickatime({
					closeOnSelect: true,
					closeOnClear: false,
					interval: 30,
					format: 'HH:i',
					clear: ''
				});
			break;

			default: // round
				$('#search-time').clockpicker({
					placement: 'bottom',
					align: 'left',
					autoclose: true,
					donetext: 'Done'
				});
			break;
		}

		switch (dpp.getLang())
		{
			case 'cs':
				$('.date-input').each(function(i, el)
				{
					$(el).val(Date.today().formatCs());
				});
			break;
			default:
				$('.date-input').each(function(i, el)
				{
					$(el).val(Date.today().formatInt());
				});
			break;
		}

		dpp.datePickers = $('.date-input').pickadate({
			format: dpp.t('dateformat'),
			monthsFull: [dpp.t('month-0'), dpp.t('month-1'), dpp.t('month-2'), dpp.t('month-3'), dpp.t('month-4'), dpp.t('month-5'), dpp.t('month-6'), dpp.t('month-7'), dpp.t('month-8'), dpp.t('month-9'), dpp.t('month-10'), dpp.t('month-11')],
			monthsShort: [dpp.t('month-0-short'), dpp.t('month-1-short'), dpp.t('month-2-short'), dpp.t('month-3-short'), dpp.t('month-4-short'), dpp.t('month-5-short'), dpp.t('month-6-short'), dpp.t('month-7-short'), dpp.t('month-8-short'), dpp.t('month-9-short'), dpp.t('month-10-short'), dpp.t('month-11-short')],
			weekdaysShort: [dpp.t('day-7'), dpp.t('day-1'), dpp.t('day-2'), dpp.t('day-3'), dpp.t('day-4'), dpp.t('day-5'), dpp.t('day-6')],
			weekdaysFull: [dpp.t('day-7-full'), dpp.t('day-1-full'), dpp.t('day-2-full'), dpp.t('day-3-full'), dpp.t('day-4-full'), dpp.t('day-5-full'), dpp.t('day-6-full')],
			today: dpp.t('calendar-today'),
			clear: '',//dpp.t('calendar-clear'),
			close: dpp.t('calendar-close'),
			formatSubmit: 'd.m.yyyy',
			hiddenSuffix: '-datepicker',
			closeOnClear: false
		});

		if (dpp.isCordova)
			$('.cordova-only').show();
		else
			$('.cordova-only').hide();

		// periodically update info
		window.setInterval(function()
		{
			console.log('Updating info...');
			dpp.updateInfoTable();
			dpp.loadCampaign();
		},
		(1000 * 60 * 10));
	},

	go2: function(page)
	{
		if (!dpp.pages[page])
			page = 'overview';

		if (page == dpp.currentPage)
			return;

		if (dpp.currentPage)
		{
			$('#page-'+dpp.currentPage).fadeOut(250, function()
			{
				$('#page-'+page).fadeIn(250);
				if (dpp.pages[page].adjustUi)
					dpp.pages[page].adjustUi();
			});

			if (dpp.pages[page].stop)
				dpp.pages[page].stop();
		}
		else
		{
			$('#page-'+page).fadeIn(250);
			if (dpp.pages[page].adjustUi)
				dpp.pages[page].adjustUi();
		}

		if (dpp.pages[page].start)
			dpp.pages[page].start();

		dpp.currentPage = page;
	},

	areaW: function()
	{
		return $(window).width();
	},

	areaH: function()
	{
		return $(window).height();
	},

	displayError: function(msg, tryAgainCb)
	{
		$('#error').outerWidth(dpp.areaW());
		$('#error-message').html(msg);

		if (tryAgainCb)
			$('#error-button').click(tryAgainCb);
		else
			$('#error-button').hide();

		$('#error').fadeIn(250);

		window.setTimeout(function()
		{
			$('#error').fadeOut(250);
		}, 5000);
	},

	displayInfo: function(msg)
	{
		$('#info').outerWidth(dpp.areaW());
		$('#info-message').html(msg);

		$('#info-button').click(function()
		{
			$('#info').fadeOut(250);
		});

		$('#info').fadeIn(250);

		window.setTimeout(function()
		{
			$('#info').fadeOut(250);
		}, 5000);
	},

	switchLang: function(code)
	{
		dpp.setLang(code);

		var debug = true;

		$("*[data-t]").each(function(i, el)
		{
			el = $(el);

			if (el.attr('data-t-id'))
			{
				if (window.translations[el.attr('data-t-id')])
				{
					if (!window.translations[el.attr('data-t-id')][code])
					{
						if (debug)
							console.log('It seems like the following element is supposed to be translated, but there is no '+code+' translation for the data-t-id.', el);
						return;
					}
				}
				else
				{
					if (debug)
						console.log('It seems like the following element is supposed to be translated, but the data-t-id ('+el.attr('data-t-id')+') is missing in the translations.', el);
					return;
				}
			}
			else
			{
				if (debug)
					console.log('It seems like the following element is supposed to be translated, but is missing data-t-id.', el);
				return;
			}

			if (el.attr('data-t') == 'content')
					el.html(window.translations[el.attr('data-t-id')][code]);

			if (el.attr('data-t') == 'title')
					el.attr('title', window.translations[el.attr('data-t-id')][code]);

			if (el.attr('data-t') == 'placeholder')
					el.attr('placeholder', window.translations[el.attr('data-t-id')][code]);

			if (el.attr('data-t') == 'alt')
					el.attr('alt', window.translations[el.attr('data-t-id')][code]);

			if (el.attr('data-t') == 'value')
					el.attr('value', window.translations[el.attr('data-t-id')][code]);
		});

		if (code == 'cs')
		{
			$('.cs-not').each(function(i, el)
			{
				if (!el.hasClass('hidden'))
					el.addClass('hidden');
			});
		}
		else
		{
			$('.cs-not').each(function(i, el)
			{
				if (el.hasClass('hidden'))
					el.removeClass('hidden');
			});
		}

		dpp.updateInfoTable();
		dpp.loadCampaign();
	},

	getLang: function()
	{
		var lang = 'cs';
		if (window.localStorage.getItem('settings-language'))
			lang = window.localStorage.getItem('settings-language');
		return lang;
	},

	setLang: function(code)
	{
		window.localStorage.setItem('settings-language', code);
	},

	t: function(id)
	{
		var lang = dpp.getLang();

		if (window.translations[id])
			if (window.translations[id][lang])
				return window.translations[id][lang];

		if (window.translations[id])
			if (window.translations[id].en)
				return window.translations[id].en;

		return '['+id+' unknown string ID]';
	},

	menuSelected: function(target)
	{
		var title = $('#app-title');

		if (dpp.pages[target].title)
		{
			title.html(dpp.t(dpp.pages[target].title));
			title.attr('data-t-id', dpp.pages[target].title);
		}

		dpp.go2(target);
	},

	showInterstitial: function()
	{
		if (dpp.isCordova)
		{
			if (AdMob)
			{
				AdMob.prepareInterstitial({
					adId: window.ads.interstitial,
					autoShow: true
				});
	    	}
    	}
    },

	showRewarded: function()
	{
		if (dpp.isCordova)
		{
			if (AdMob)
			{
				AdMob.prepareRewardVideoAd({
					adId: window.ads.interstitial,
					autoShow: true
				});
	    	}
    	}
    },

    tip: function(id)
    {
    	var totalTips = 10;

    	if (!id)
    		id = Math.floor(Math.random() * (totalTips - 1)) + 1;

    	return dpp.t('tip-'+id);
    },

	showLoading: function()
	{
		var loading = $('#loading');
		loading.css({width: dpp.areaW() +'px', height: dpp.areaH() +'px'});
		loading.show();
	},

	hideLoading: function()
	{
		$('#loading').hide();
	},

	share: function(message, subject, url, title, eventName)
	{
		if (dpp.isCordova)
		{
			window.plugins.socialsharing.shareWithOptions({
				message: message,
				subject: subject,
				url: url,
				chooserTitle: title
			},
			function() // success
			{
				ga('send', 'event', 'General', eventName+'Finished');
			},
			null);

			ga('send', 'event', 'General', eventName+'Clicked');
		}
	},

	forward: function(event)
	{
		if (dpp.isCordova)
		{
			console.log('This is cordova, processing the URL further...');

			event.preventDefault();

			if (event.currentTarget.href.indexOf('https://play.google.com/') === 0)
			{
				var id = event.currentTarget.href.split('=')[1];
				console.log("It's a Google Play link, opening Google Play instead.", id);

				cordova.plugins.market.open(id);
				return;
			}
			else
			{
				console.log('Regular link.', event.currentTarget.href);
				cordova.InAppBrowser.open(event.currentTarget.href, '_system');
			}
		}
	},

	getStoredValue: function(name, altValue)
	{
		var value = window.localStorage.getItem(name);
		
		if ((value === null) || (value === undefined))
			return altValue;
		
		return value;
	},

	autocompleteStops: function(search, sync, async)
	{
		if (search === '')
		{
			var recentStops = dpp.pages.search.getRecentStops();
			var count = parseInt(dpp.getStoredValue('settings-lastStationsCount', 5));

			var recentStopsLimited = [];

			for (var i in recentStops)
			{
				if (count > 0)
					recentStopsLimited.push(recentStops[i]);

				count--;
			}


			sync(recentStopsLimited);
		}
		else
		{
			var url = dpp.safeUrl("http://spojeni.dpp.cz/AJAXService.asmx/SearchTimetableObjectsJSONP?q='"+search+"'&limit=20&timestamp="+Date.now()+"&selectedTT='PID'&bindElementValue=&iLang='CZECH'&bCoor=false&format=json");
			
			$.ajax({
				type: 'GET',
				url: url,
				complete: function(data, status)
				{
					if (data.status == 200)
					{
						var stations = JSON.parse(data.responseText.substring(1, data.responseText.length - 2));
						
						var src = [];
						for (var i in stations.d)
							src.push(stations.d[i].oItem.sName);

						async(src);
					}
					else
						console.log(data.statusText);
				}
			});
		}
	},

	addAutocomplete: function()
	{
		var inputs = $('.station-input');
		inputs.each(function(key, val)
		{
			$(val).typeahead({
				minLength: 0,
				highlight: true,
				hint: false 
			},
			{
    			name: 'stations',
				source: dpp.autocompleteStops
			});
		});
	},

	updateInfoTable: function()
	{
		$('#search-info-table').html('');
		
		// Author's ad
		dpp.loadAuthorAd();

		// Ticket checks
		dpp.pages.checks.loadFirstReport();

		// News
		dpp.pages.news.loadExtraEvents();

		// Tip
		var html = '<tr><td><i class="fa fa-lightbulb-o" style="color: #f0ad4e; font-size: 24px;"></i></td><td colspan="2">'+dpp.tip()+'</td></tr>';
		$('#search-info-table').append(html);
	},

	loadAuthorAd: function()
	{
		$.get('http://res.dppapp.cz/ad.php', {}, function(response)
		{
			var content = ''
			if (response[dpp.getLang()])
				content = response[dpp.getLang()];
			else
				content = response['en'];

			var html = '<tr><td><i class="fa fa-globe" style="color: #5bc0de; font-size: 20px;"></i></td><td id="search-info-table-authorad" colspan="2">'+content+'</td></tr>';
			$('#search-info-table').prepend(html);
			$('#search-info-table-authorad a').click(dpp.forward);
		});
	},

	safeUrl: function(url)
	{
		console.log('Processing URL...', url);

		if (dpp.isCordova)
			return url;

		return 'http://zeta.e0.cz:18080/'+url;
	},

	copy: function(text)
	{
		if (dpp.isCordova)
		{
			cordova.plugins.clipboard.copy(text);
			dpp.displayInfo(dpp.t('copy-done'));
		}
		else
			window.prompt(dpp.t('copy-prompt'), text);
	},

	confirm: function(title, text, action)
	{
		$('#modal-confirm-title').html(title);
		$('#modal-confirm-text').html(text);
		$('#modal-confirm-action').attr('onclick', action);
		$('#modal-confirm').modal('show');
	},

	alert: function(title, text)
	{
		$('#modal-alert-title').html(title);
		$('#modal-alert-text').html(text);
		$('#modal-alert').modal('show');
	},

	getFreeNotificationId: function(cb)
	{
		cordova.plugins.notification.local.getScheduled(function(list)
		{
			var ids = [];

			for (var i in list)
				ids.push(list[i].id);

			var newId = 1;

			for (var newId = 1; newId < 10000; newId++)
			{
				if (ids.indexOf(newId) < 0)
				{
					cb(newId);
					return;
				}
			}
		});
	},

	loadCampaign: function()
	{
		var el = $('#search-campaign');
		el.html('');
		$.get('http://res.dppapp.cz/campaign.php', {}, function(campaign)
		{
			if (campaign.display || dpp.getStoredValue('debug', false))
			{
				for (var i in campaign.periods)
				{
					$.get('http://res.dppapp.cz/api/?action=getaddismisses&period='+campaign.periods[i].length, function(dismisses)
					{
						var percentage = Math.round(dismisses.data.dismisses / campaign.periods[i].needed * 100);
						var percentage2 = (dismisses.data.dismisses / campaign.periods[i].needed * 100).toFixed(2);

						if (percentage > 100)
							percentage = 100;

						var whatsThisContent = "'<p>'+dpp.t('ads-explaination-text1')+'</p><p>'+dpp.t('ads-explaination-text2')+'</p><h5>'+dpp.t('ads-explaination-heading1')+'</h5><p>'+dpp.t('ads-explaination-text3')+'</p>'";
						var whatsThisButton = "<a href=\"#\" onclick=\"dpp.alert(dpp.t('ads-explaination-title'), "+whatsThisContent+")\">"+dpp.t('search-ad-whatsthis')+'</a>';

						if (campaign.periods[i].labels[dpp.getLang()])
							el.append('<small class="text-muted" style="display: block;">'+campaign.periods[i].labels[dpp.getLang()]+' ('+whatsThisButton+')</small>');
						else
							el.append('<small class="text-muted" style="display: block;">'+campaign.periods[i].labels.en+' ('+whatsThisButton+')</small>');

						var color = 'danger';
						if (percentage >= 25) color = 'warning';
						if (percentage >= 50) color = 'info';
						if (percentage >= 75) color = 'success';

						var rating = 0;
						if (percentage >= 25) rating = 25;
						if (percentage >= 50) rating = 50;
						if (percentage >= 75) rating = 75;
						if (percentage >= 100) rating = 100;

				        el.append('<progress class="progress progress-'+color+'" value="'+percentage+'" max="100" style="height: 10px; width: 80%; display: inline-block; margin: 0;"></progress>');
				        el.append('<small class="text-muted" style="display: block;">'+percentage2+' % - '+dpp.t('search-ad-'+rating)+'</small>');
					});
				}
			}
		});
	}
}