
dpp.pages.checks = {

	title: 'menu-checks',

	start: function()
	{
		ga('send', 'event', 'General', 'ViewChecks');

		dpp.pages.checks.loadReports();
	},

	loadReports: function()
	{
		dpp.showLoading();
		$.get('http://res.dppapp.cz/api/?action=getchecks', {}, function(response)
		{
			if (response.status == 'ok')
			{
				var html = dpp.t('checks-noreports');

				if (response.data.checks.length > 0)
				{
					html = '<table class="table table-sm table-striped" style="background-color: #ffffff;"><tbody>';
					html += '<thead><tr><th>'+dpp.t('checks-where')+'</th><th>'+dpp.t('checks-time')+'</th></tr></thead>';

					for (var i in response.data.checks)
						html += '<tr><td>'+response.data.checks[i].where+'</td><td>'+(new Date(parseInt(response.data.checks[i].created) * 1000).time24())+'</td></tr>'

					html += '</tbody></table>';
				}

				$('#checks-list').html(html);
			}
		})
	  	.always(function()
	  	{
	  		dpp.hideLoading();
	  	});
	},

	loadFirstReport: function()
	{
		$.get('http://res.dppapp.cz/api/?action=getchecks', {}, function(response)
		{
			if (response.status == 'ok')
			{
				if (response.data.checks.length > 0)
				{
					var html = '<tr><td><i class="fa fa-hand-paper-o" style="color: #e12d28; font-size: 20px;"></i></td id="search-info-table-authorad"><td>'+(new Date(parseInt(response.data.checks[0].created) * 1000).time24())+' '+response.data.checks[0].where+'</td><td><button class="btn btn-sm btn-outline-primary" onclick="dpp.go2(\'checks\')"><i class="fa fa-arrow-right"></i></button></td></tr>';
					$('#search-info-table').prepend(html);
				}
			}
		});
	},

	report: function()
	{
		var where = $('#checks-where').val();

		if (where)
		{
			dpp.showLoading();
			$.get('http://res.dppapp.cz/api/?action=addcheck&where='+where, {}, function(response)
			{
				if (response.status == 'ok')
				{
					dpp.pages.checks.loadReports();
					dpp.displayInfo(dpp.t('checks-thanks'));
				}
				else
					dpp.displayError(dpp.t('checks-error2'));
			})
		  	.always(function()
		  	{
		  		dpp.hideLoading();
		  	});
		}
		else
			dpp.displayError(dpp.t('checks-error1'));
	}
}