
dpp.pages.map = {

	title: 'map-title',
	search: '',
	gMap: null,
	infoWindow: null,
	prague: {
		lat: 50.075967,
		lng: 14.470711
	},
	userLocation: null,
	currentMarkers: [],

	start: function()
	{
		ga('send', 'event', 'General', 'ViewMap');

		console.log('Getting device location...');

		if (navigator.geolocation)
			navigator.geolocation.getCurrentPosition(function(position)
			{
				dpp.pages.map.userLocation = {
					lat: position.coords.latitude,
					lng: position.coords.longitude
				};
				
				console.log('Device location:'+dpp.pages.map.userLocation);
				dpp.pages.map.checkMap();
			},
			function(err)
			{
				console.log(err);
				dpp.pages.map.userLocation = dpp.pages.map.prague;
				console.log('No permissions. Device location set to Prague.');
				dpp.pages.map.checkMap();
			});
		else
		{
			console.log('No navigator.geolocation. Device location set to Prague.');
			dpp.pages.map.userLocation = dpp.pages.map.prague;
			dpp.pages.map.checkMap();
		}
	},

	checkMap: function()
	{
		if (!dpp.pages.map.gMap)
		{
			dpp.pages.map.loadGMapApi();
			return;
		}

		dpp.pages.map.performSearch();
	},

	adjustUi: function()
	{
		$('#map-canvas').height(dpp.areaH() - 54);
	},

	loadGMapApi: function()
	{
		console.log('Loading map API...');
		$('body').append('<script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyBD4wB8_QHIHSZ4c5gf8AYlFzJbHC45bWY&callback=dpp.pages.map.initMap&libraries=places"></script>');
	},

	initMap: function()
	{
		console.log('Initializing map...');

		dpp.pages.map.gMap = new window.google.maps.Map(document.getElementById('map-canvas'), {
		    center: dpp.pages.map.userLocation,
		    zoom: 3,
		    mapTypeId: 'roadmap'
		});

		dpp.pages.map.performSearch();
	},

	prepareSearch: function(query)
	{
		dpp.pages.map.search = query;

		dpp.menuSelected('map');
	},

	performSearch: function()
	{
		console.log('Searching...');

		if (dpp.pages.map.search == 'nearby-stops')
		{
			dpp.pages.map.gMap.setZoom(15);

			var service = new google.maps.places.PlacesService(dpp.pages.map.gMap);

			service.nearbySearch({
				location: dpp.pages.map.userLocation,
				radius: 1000,
				type: [/*'bus_station', 'train_station', 'subway_station', */'transit_station']
			},
			function(results, status)
			{
				if (status === google.maps.places.PlacesServiceStatus.OK)
					dpp.pages.map.displayResults(results);
			});

			return;
		}


		// default: query search

		/*
		dpp.pages.map.gMap.setCenter(dpp.pages.map.prague);
		dpp.pages.map.gMap.setZoom(3);

		service.nearbySearch({
			location: dpp.pages.map.userLocation,
			radius: 1000,
			//type: ['bus_station', 'train_station', 'subway_station', 'transit_station']
		},
		function(results, status)
		{
			if (status === google.maps.places.PlacesServiceStatus.OK)
				dpp.pages.map.displayResults(results);
		});*/
	},

	displayResults: function(results)
	{
		if (dpp.pages.map.currentMarkers.length)
		{
			console.log('Deleting previus markers...');

			for (var i in dpp.pages.map.currentMarkers)
				dpp.pages.map.currentMarkers[i].setMap(null);

			dpp.pages.map.currentMarkers = [];
		}

		if (!dpp.pages.map.infoWindow)
			dpp.pages.map.infoWindow = new google.maps.InfoWindow({
				content: ''
			});
		else
			dpp.pages.map.infoWindow.close();

		for (var i in results)
		{
			var marker = new google.maps.Marker({
				map: dpp.pages.map.gMap,
				position: results[i].geometry.location
			});

			marker.stop = results[i].name;

			dpp.pages.map.currentMarkers.push(marker);
        }

        for (var i in dpp.pages.map.currentMarkers)
        {
			google.maps.event.addListener(dpp.pages.map.currentMarkers[i], 'click', function()
			{
				dpp.pages.map.infoWindow.setContent('<b>'+this.stop+'</b>');
				dpp.pages.map.infoWindow.open(dpp.pages.map.gMap, this);
				//$('.gm-style-iw > div').css({width: 200+'px', 'max-width': 200+'px'});
	        });
        }
	}
}