
dpp.pages.news = {

	title: 'menu-news',

	start: function()
	{
		ga('send', 'event', 'General', 'ViewNews');

		$('div.news-extra-description').each(function(i, el)
		{
			el = $(el);

			if (el.is(':empty'))
			{
				$.get(dpp.safeUrl('http://www.dpp.cz/mimoradne-udalosti/'+el.attr('data-post-id')+'/'), {}, function(response)
				{
					var description = $(response).find('div#pole strong')[5].innerHTML.trim();

					if (dpp.getLang() != 'cs')
						description += '<div class="news-translation" style="margin-top: 6px;"><button class="btn btn-sm btn-outline-info" onclick="dpp.pages.news.extraTranslateText(this)" data-t="content" data-t-id="google-translate" data-original="'+description+'">'+dpp.t('google-translate')+'</button><div>';

					el.html(description);
				});
			}
			else
			{
				if (dpp.getLang() == 'cs')
					$('.news-translation').hide();
				else
					$('.news-translation').show();
			}
		});
	},

	extraTranslateText: function(el)
	{
		el = $(el);

		var query = 'https://translate.googleapis.com/translate_a/single?client=gtx&sl=cs&tl='+dpp.getLang()+'&dt=t&q='+encodeURIComponent(el.attr('data-original'));

		dpp.showLoading();
		$.get(query, {}, function(response)
		{
			response = response.replace(/,{2,}/g, ',');
			response = JSON.parse(response);
			response = response[0];

			var text = [];
			for (var i  in response)
				text.push(response[i][0]);

			el.parent().html(text.join(' '));

		}, 'text')
	  	.always(function()
	  	{
	  		dpp.hideLoading();
	  	});
	},

	go2Tab: function(tab)
	{
		$('#'+tab).tab('show');
		dpp.go2('news');
	},

	loadExtraEvents: function()
	{
		$.get(dpp.safeUrl('http://www.dpp.cz/mimoradne-udalosti/'), {}, function(response)
		{
			dpp.pages.news.parseExtraEvents(response);
		});
	},

	parseExtraEvents: function(html)
	{
		var headings = [];
		var details = [];
		var content = $(html).find('div#pole').find('div.left').children();

		var detail;
		var lines;
		var duration;
		var type;
		var id;

		content.each(function(i, child)
		{
			child = $(content[i]);

			if (child.prop('tagName') == 'H2')
				headings.push(child.html());

			if (child.prop('tagName') == 'P')
			{
				detail = child.find('span');

				duration = $(detail[1]).text().match(/\d+/g);
				if (duration)
				{
					lines = $(detail[2]).text().match(/\d+/g);
					type = $(detail[3]).text().split("\n")[1].trim();
					id = child.find('a').attr('href').split('/')[2];

					duration = {
						from: {
							date: duration[0]+'.'+duration[1]+'.',
							time: duration[2]+':'+duration[3]
						},
						to: {
							date: duration[4]+'.'+duration[5]+'.',
							time: duration[6]+':'+duration[7]
						}
					}

					details.push({
						duration: duration,
						lines: lines,
						type: type,
						id: id
					});
				}
			}
		})
		.promise()
		.done(function()
		{
			var news = {};
			for (var i in headings)
				if (details[i])
					news[i] = {
						span: headings[i],
						duration: details[i].duration,
						lines: details[i].lines,
						type: details[i].type,
						id: details[i].id
					};

			dpp.pages.news.displayExtraEvents(news);
		});
	},

	displayExtraEvents: function(events)
	{
		// display events on the news page

		var html;
		var content = [];
		var type;

		for (var i in events)
		{
			events[i].type = events[i].type.trim();

			switch (events[i].type)
			{
				case 'Provoz omezen':
					type = '<span data-t="content" data-t-id="news-extra-type-1">'+dpp.t('news-extra-type-1')+'</span>';
				break;
				case 'Zpoždění spojů':
					type = '<span data-t="content" data-t-id="news-extra-type-2">'+dpp.t('news-extra-type-2')+'</span>';
				break;
				case 'Provoz zastaven':
					type = '<span data-t="content" data-t-id="news-extra-type-3">'+dpp.t('news-extra-type-3')+'</span>';
				break;
				case 'Provoz zastaven, zavedena NAD':
					type = '<span data-t="content" data-t-id="news-extra-type-4">'+dpp.t('news-extra-type-4')+'</span>';
				break;
				case 'Ostatní':
					type = '<span data-t="content" data-t-id="news-extra-type-5">'+dpp.t('news-extra-type-5')+'</span>';
				break;
				default:
					type = '<span>'+events[i].type+'</span>';
				break;
			}

			html = '';
			html += '<h5>'+events[i].span+'</h5>';
			html += '<div class="news-panel">';
			html += '<div><b data-t="content" data-t-id="news-extra-duration">'+dpp.t('news-extra-duration')+'</b>: '+events[i].duration.from.date+' '+events[i].duration.from.time+' - '+events[i].duration.to.date+' '+events[i].duration.to.time+'</div>';
			html += '<div><b data-t="content" data-t-id="news-extra-lines">'+dpp.t('news-extra-lines')+'</b>: <span style="font-family: monospace;">'+events[i].lines.join(', ')+'</span></div>';
			html += '<div><b data-t="content" data-t-id="news-extra-type">'+dpp.t('news-extra-type')+'</b>: '+type+'</div>';
			html += '</div>';
			html += '<div class="news-extra-description" data-post-id="'+events[i].id+'" style="margin-top: 6px;"></div>';
			html += '<div style="height: 27px; margin-top: 6px;"><a class="btn btn-sm btn-outline-primary pull-right news-extra-link" href="http://www.dpp.cz/mimoradne-udalosti/'+events[i].id+'/" target="_blank" data-t="content" data-t-id="viewondpp">'+dpp.t('viewondpp')+'</a></div>';
			content.push(html);
		}

		$('#news-transport-extra').html(content.join('<hr>'));
		$('.news-extra-link').click(dpp.forward);

		// display lines in the info table

		var allLines = [];

		for (var i in events)
			allLines = allLines.concat(events[i].lines);

		allLines.push('143');

		var listedLines = [];
		for (var i in allLines)
			if (listedLines.indexOf(allLines[i]) < 0)
				listedLines.push(allLines[i]);

		html = '<tr><td><i class="fa fa-exclamation-triangle" style="color: #e12d28; font-size: 20px;"></i></td><td style="font-family: monospace;">'+listedLines.join(', ')+'</td><td><button class="btn btn-sm btn-outline-primary" onclick="dpp.pages.news.go2Tab(\'news-transport-extra\')"><i class="fa fa-arrow-right"></i></button></td></tr>';
		$('#search-info-table').prepend(html);
	}
}