
dpp.pages.savedconnections = {

	title: 'savedconnections-title',
	currentNotificationConnectionId: null,

	start: function()
	{
		ga('send', 'event', 'General', 'ViewSavedConnections');

		dpp.pages.savedconnections.loadSavedConnections();
	},
		
	loadSavedConnections: function()
	{
		var savedConnections = window.localStorage.getItem('savedConnections');
		
		if (!savedConnections)
			return;
		
		savedConnections = JSON.parse(savedConnections);

		if (savedConnections.length)
		{
			var list = dpp.pages.savedconnections.formatConnections(savedConnections);
			$('#page-savedconnections').html(list);
		}
		else
			$('#page-savedconnections').html('<p data-t-id="savedconnections-none1" data-t="content">'+dpp.t('savedconnections-none1')+'</p><p data-t-id="savedconnections-none2" data-t="content">'+dpp.t('savedconnections-none2')+'</p>');
	},
	
	saveConnection: function(el, id)
	{
		$(el).remove();

		var savedConnections = window.localStorage.getItem('savedConnections');
		var newSavedConnections = [dpp.pages.search.lastSearchResults[id]];

		if (savedConnections)
		{
			savedConnections = JSON.parse(savedConnections);

			for (var i in savedConnections)
				newSavedConnections.push(savedConnections[i]);
		}
		
		window.localStorage.setItem('savedConnections', JSON.stringify(newSavedConnections));
		dpp.pages.savedconnections.loadSavedConnections();
	},
	
	removeConnection: function(id)
	{
		var savedConnections = window.localStorage.getItem('savedConnections');

		if (savedConnections)
		{
			savedConnections = JSON.parse(savedConnections);

			if (savedConnections[id])
				savedConnections.splice(id, 1);
		}
		
		window.localStorage.setItem('savedConnections', JSON.stringify(savedConnections));
		dpp.pages.savedconnections.loadSavedConnections();
	},

	formatConnections: function(routes)
	{
		var list = '';
		
		for (var route in routes)
		{
			if (dpp.getLang() != 'cs')
			{
				routes[route].transfers = routes[route].transfers.replace('přestup', dpp.t('search-transfer'));
				routes[route].transfers = routes[route].transfers.replace('přestupy', dpp.t('search-transfers'));
			}

			routes[route].travelTime = routes[route].travelTime.replace('hod', dpp.t('search-hour-short'));
			routes[route].travelTime = routes[route].travelTime.replace('min.', dpp.t('search-minute-short'));
			routes[route].travelTime = routes[route].travelTime.replace('min', dpp.t('search-minute-short'));

			list += '<div class="card route" style="text-align: center;">';
			list += '<div class="card-header"><b>'+routes[route].departure+' - '+routes[route].arrival+', '+routes[route].travelTime+'., '+routes[route].price+' '+(dpp.getLang()!='cs'?'CZK':'Kč')+', '+routes[route].transfers+'</b></div>';
			list += '<div class="card-block">';
			
			list += '<ol>';
			var step;
			for (var stepIterator in routes[route].steps)
			{
				step = routes[route].steps[stepIterator];
				
				if (step.type == 'drive')
				{
					// start station
					list += '<li><b>'+step.info.start.station+'</b> ';
					for (var sign in step.info.start.signs)
						list += '<img src="img/FC/'+step.info.start.signs[sign]+'" alt="">';
					list += ' '+step.info.start.time+'</b> ';
					
					// line
					var color;
					switch (step.info.driveLine)
					{
						case 'A': color = 'green'; break;
						case 'B': color = '#fec831'; break;
						case 'C': color = 'red'; break;
						default: color = 'inherit'; break;
					}
					
					list += ' &rarr; ';
					list += '<img src="img/'+step.info.driveSign+'" alt=""> <b style="color: '+color+';">'+step.info.driveLine+'</b>';
					list += ' &rarr; ';
					
					// end station
					list += '<b>'+step.info.finish.station+'</b> ';
					for (var sign in step.info.finish.signs)
						list += '<img src="img/FC/'+step.info.finish.signs[sign]+'" alt="">';
					list += ' '+step.info.finish.time+'</b></li>';
				}
				
				if (step.type == 'walk')
					list += step.info;
				/*{
					if (dpp.getLang() != 'cs')
					{
						step.info = step.info.replace('Přesun pěšky asi', 'Transfer by foot, about');
						step.info = step.info.replace('minuty', 'many');
						step.info = step.info.replace('minuta', 'one');
						step.info = step.info.replace('minut', 'many');

						step.info = step.info.replace('one', dpp.t('search-minute'));
						step.info = step.info.replace('many', dpp.t('search-minutes'));
					}

					list += '<span class="routes-walk">'+step.info+'</span>';
				}*/
			}
			list += '</ol>';
			
			list += '</div>';
			list += '<div class="card-footer" style="text-align: center;">';

			var departureTime = routes[route].departure.split(':');
			var departure = new Date(routes[route].departureDate);
			departure.setHours(departureTime[0]);
			departure.setMinutes(departureTime[1]);

			// only show the time notification button if this connection is still in the "future" (at least 5 minutes)
			if (departure > (new Date()).add({minutes: 5}))
				list += '<button type="button" class="btn btn-outline-primary btn-sm pull-left" onclick="dpp.pages.savedconnections.notificationModal(\''+route+'\');"><i class="fa fa-clock-o"></i></button>';

			list += '<button type="button" class="btn btn-outline-info btn-sm" onclick="dpp.pages.savedconnections.share(\''+route+'\');" style="margin-right: 24px;"><i class="fa fa-share"></i></button>';
			list += '<button type="button" class="btn btn-outline-info btn-sm" onclick="dpp.pages.savedconnections.copy(\''+route+'\');"><i class="fa fa-clipboard"></i></button>';
			list += '<button type="button" class="btn btn-outline-primary btn-sm pull-right" onclick="dpp.pages.savedconnections.removeConnection(\''+route+'\');"><i class="fa fa-remove"></i></button>';
			list += '</div>';
			list += '</div>';
		}
		
		return list;
	},

	notificationModal: function(connectionId)
	{
		var savedConnections = window.localStorage.getItem('savedConnections');

		if (savedConnections)
		{
			savedConnections = JSON.parse(savedConnections);

			if (savedConnections[connectionId])
			{
				var departureTime = savedConnections[connectionId].departure.split(':');
				var departure = new Date(savedConnections[connectionId].departureDate);
				departure.setHours(departureTime[0]);
				departure.setMinutes(departureTime[1]);

				var now = new Date();

				if (departure > now)
				{
					var difference = Math.round((departure - now) / 1000 / 60); // difference in minutes

					var options = '';

					if (difference > 5)
						options += '<option value="'+departure.add({minutes: -5}).getTime()+'">5 '+dpp.t('modal-notification-earlier')+'</option>';
					if (difference > 10)
						options += '<option value="'+departure.add({minutes: -5}).getTime()+'">10 '+dpp.t('modal-notification-earlier')+'</option>';
					if (difference > 15)
						options += '<option value="'+departure.add({minutes: -5}).getTime()+'">15 '+dpp.t('modal-notification-earlier')+'</option>';
					if (difference > 20)
						options += '<option value="'+departure.add({minutes: -5}).getTime()+'">20 '+dpp.t('modal-notification-earlier')+'</option>';
					if (difference > 25)
						options += '<option value="'+departure.add({minutes: -5}).getTime()+'">25 '+dpp.t('modal-notification-earlier')+'</option>';
					if (difference > 30)
						options += '<option value="'+departure.add({minutes: -5}).getTime()+'">30 '+dpp.t('modal-notification-earlier')+'</option>';
					if (difference > 45)
						options += '<option value="'+departure.add({minutes: -15}).getTime()+'">45 '+dpp.t('modal-notification-earlier')+'</option>';
					if (difference > 60)
						options += '<option value="'+departure.add({minutes: -15}).getTime()+'">60 '+dpp.t('modal-notification-earlier')+'</option>';

					if (options.length)
					{
						dpp.pages.savedconnections.currentNotificationConnectionId = connectionId;
						$('#modal-notification-select').html(options);
						$('#modal-notification').modal('show');
					}
					else
						dpp.displayError(dpp.t('savedconnections-connectiongone'));
				}
				else
					dpp.displayError(dpp.t('savedconnections-connectiongone'));
			}
		}
	},

	registerNotificationCallback: function()
	{
		if (dpp.isCordova)
			cordova.plugins.notification.local.on("click", function (notification)
			{
				var data = JSON.parse(notification.data);

				if (data.type == 'connection')
				{
					dpp.pages.notification1.connection = data.connection;
					dpp.go2('notification1');
				}
			});
	},

	setupNotification: function()
	{
		if (dpp.isCordova)
		{
			console.log('Checking for permissions...');

			cordova.plugins.notification.local.hasPermission(function (doesHave)
			{
				if (!doesHave)
				{
					console.log('Requesting notifications permission...');

					cordova.plugins.notification.local.registerPermission(function(granted)
					{
						if (granted)
						{
							console.log('Obtained notifications permission.');
							dpp.pages.savedconnections.scheduleNotification(dpp.pages.savedconnections.currentNotificationConnectionId, $('#modal-notification-select').val());
						}
						else
							console.log("Didn't get notifications permission.");
					});
				}
				else
				{
					console.log('Do have permissions.');
					dpp.pages.savedconnections.scheduleNotification(dpp.pages.savedconnections.currentNotificationConnectionId, $('#modal-notification-select').val());
				}
			});
		}
	},

	getLastStation: function(connectionId)
	{
		var savedConnections = window.localStorage.getItem('savedConnections');

		if (savedConnections)
		{
			savedConnections = JSON.parse(savedConnections);

			if (savedConnections[connectionId])
			{
				var lastStep = savedConnections[connectionId].steps[savedConnections[connectionId].steps.length - 1];
				return lastStep.info.finish.station;
			}
		}

		return '';
	},

	scheduleNotification: function(connectionId, time)
	{
		var when = new Date(parseInt(time));
		dpp.getFreeNotificationId(function(notificationId)
		{
			console.log('Scheduling notification...', 'Connection ID', connectionId, 'Notification ID', notificationId, 'Time', when);

			var savedConnections = window.localStorage.getItem('savedConnections');
			savedConnections = JSON.parse(savedConnections);

			var departure = new Date(savedConnections[connectionId].departureDate)
			departure.setHours(savedConnections[connectionId].departure.split(':')[0]);
			departure.setMinutes(savedConnections[connectionId].departure.split(':')[1]);

			var remainingMinutes = Math.round((departure - time) / 60000);

			cordova.plugins.notification.local.schedule({
				id: notificationId,
				title: dpp.t('notification1-title')+remainingMinutes,
				text: dpp.t('notification1-text1')+dpp.pages.savedconnections.getLastStation(connectionId)+dpp.t('notification1-text2'),
				at: when,
				sound: 'file://notification.mp3',
				icon: 'res://notificationicon512.png',
				smallIcon: 'res://statusbaricon32.png',
				data: {
					type: 'connection',
					connection: savedConnections[connectionId]
				}
			});
		});
	},

	getTextual: function(id)
	{
		var savedConnections = window.localStorage.getItem('savedConnections');
		savedConnections = JSON.parse(savedConnections);
		var connection = savedConnections[id];

		var text = '';
		var step;
		for (var stepIterator in connection.steps)
		{
			step = connection.steps[stepIterator];
			
			if (step.type == 'drive')
				text += step.info.start.station + ' ' +step.info.start.time+ ' >>> ' +step.info.driveLine+ ' >>> ' +step.info.finish.time+ ' ' +step.info.finish.station + "\n";
			
			if (step.type == 'walk')
				text += step.info+"\n";
		}

		return text;
	},

	share: function(id)
	{
		dpp.share(dpp.pages.savedconnections.getTextual(id), dpp.t('savedconnections-share-subject'), dpp.t('savedconnections-share-link'), dpp.t('savedconnections-share-title'), 'ShareConnection');
	},

	copy: function(id)
	{
		dpp.copy(dpp.pages.savedconnections.getTextual(id));
	}
}