
dpp.pages.scheme = {

	title: 'menu-scheme',

	defaultWidth: 0,
	defaultHeight: 0,
	currentZoom: 1,

	start: function()
	{
		ga('send', 'event', 'General', 'ViewScheme');

		dpp.pages.scheme.displayScheme();
	},

	adjustUi: function()
	{
		$('#scheme-canvas').height(dpp.areaH() - 212);
	},

	setZoom: function(zoom)
	{
		dpp.pages.scheme.currentZoom = zoom;

		$('#scheme-canvas-img').width(Math.floor(dpp.pages.scheme.defaultWidth * zoom));
		$('#scheme-canvas-img').height(Math.floor(dpp.pages.scheme.defaultHeight * zoom));

		$('#scheme-currentzoom').html(zoom+' &times;');
	},

	zoomIn: function()
	{
		var newZoom = Math.round((dpp.pages.scheme.currentZoom + .2) * 10) / 10;;

		if (newZoom <= 2)
			dpp.pages.scheme.setZoom(newZoom);
	},

	zoomOut: function()
	{
		var newZoom = Math.round((dpp.pages.scheme.currentZoom - .2) * 10) / 10;;

		if (newZoom >= .2)
			dpp.pages.scheme.setZoom(newZoom);
	},

	centerView: function()
	{
		var currentWidth = Math.floor(dpp.pages.scheme.defaultWidth * dpp.pages.scheme.currentZoom);
		var currentHeight = Math.floor(dpp.pages.scheme.defaultHeight * dpp.pages.scheme.currentZoom);

		var viewportWidth = dpp.areaW();
		var viewportHeight = (dpp.areaH() - 212);

		var scrollX = Math.round((currentWidth / 2) - (viewportWidth / 2));
		var scrollY = Math.round((currentHeight / 2) - (viewportHeight / 2));

		$('#scheme-canvas').scrollTop(scrollX);
		$('#scheme-canvas').scrollLeft(scrollY);
	},

	displayScheme: function()
	{
		var image = 'img/schemes/'+$('#scheme-selection').val();

		$('#scheme-canvas').html('');
		$('#scheme-canvas').html('<img id="scheme-canvas-img" src="'+image+'" alt="" onload="dpp.pages.scheme.schemeDisplayed()">');
	},

	schemeDisplayed: function()
	{
		setTimeout(function()
		{
			dpp.pages.scheme.defaultWidth = $('#scheme-canvas-img').width();
			dpp.pages.scheme.defaultHeight = $('#scheme-canvas-img').height();

			dpp.pages.scheme.setZoom(.4);
			dpp.pages.scheme.centerView();
		},
		1000);
	}
}